ghc-7.0.3: The GHC API

ByteCodeInstr

# Documentation

data BCInstr

Constructors

STKCHECK Word |
PUSH_L !Word16 |
PUSH_LL !Word16 !Word16 |
PUSH_LLL !Word16 !Word16 !Word16 |
PUSH_G Name |
PUSH_PRIMOP PrimOp |
PUSH_BCO (ProtoBCO Name) |
PUSH_ALTS (ProtoBCO Name) |
PUSH_ALTS_UNLIFTED (ProtoBCO Name) CgRep |
PUSH_UBX (Either Literal (Ptr ())) Word16 |
PUSH_APPLY_N |
PUSH_APPLY_V |
PUSH_APPLY_F |
PUSH_APPLY_D |
PUSH_APPLY_L |
PUSH_APPLY_P |
PUSH_APPLY_PP |
PUSH_APPLY_PPP |
PUSH_APPLY_PPPP |
PUSH_APPLY_PPPPP |
PUSH_APPLY_PPPPPP |
SLIDE Word16 Word16 |
ALLOC_AP !Word16 |
ALLOC_AP_NOUPD !Word16 |
ALLOC_PAP !Word16 !Word16 |
MKAP !Word16 !Word16 |
MKPAP !Word16 !Word16 |
UNPACK !Word16 |
PACK DataCon !Word16 |
LABEL LocalLabel |
TESTLT_I Int LocalLabel |
TESTEQ_I Int LocalLabel |
TESTLT_W Word LocalLabel |
TESTEQ_W Word LocalLabel |
TESTLT_F Float LocalLabel |
TESTEQ_F Float LocalLabel |
TESTLT_D Double LocalLabel |
TESTEQ_D Double LocalLabel |
TESTLT_P Word16 LocalLabel |
TESTEQ_P Word16 LocalLabel |
CASEFAIL |
JMP LocalLabel |
CCALL Word16 (Ptr ()) |
SWIZZLE Word16 Word16 |
ENTER |
RETURN |
RETURN_UBX CgRep |
BRK_FUN (MutableByteArray# RealWorld) Word16 BreakInfo |

Instances

Outputable BCInstr |

data ProtoBCO a

Constructors

ProtoBCO |

Fields

protoBCOName :: a
protoBCOInstrs :: [BCInstr]
protoBCOBitmap :: [StgWord]
protoBCOBitmapSize :: Word16
protoBCOArity :: Int
protoBCOExpr :: Either [AnnAlt Id VarSet] (AnnExpr Id VarSet)
protoBCOPtrs :: [Either ItblPtr (Ptr ())]

Instances

Outputable a => Outputable (ProtoBCO a) |

bciStackUse :: BCInstr -> Word

data BreakInfo

Constructors

BreakInfo |

Fields

breakInfo_module :: Module
breakInfo_number :: !Int
breakInfo_vars :: [(Id, Word16)]
breakInfo_resty :: Type

Instances

Outputable BreakInfo |